Subject: [Dime] Clarification regarding Error code 4003.(Election lost)

From: "Balamurugan T, TLS-Chennai" <[email-masked]>
Date: Wed, 18 Jul 2007 20:24:49 +0530

Hi All,

I need some clarification regarding Error code 4003.

RFC says " ELECTION_LOST 4003  The peer has determined that it has lost the election process and has

therefore disconnected the transport connection. "

In Peer state machine, the Initiator of a connection disconnects it on election win and sending CEA over responding

connection. Do we need to send CEA in Initiated connection before closing the connection?. If the answer is no,

which CEA will add this error code.

Can anyone explain the actual   usage of this error code.

Thanks in Advance,

Bala

DISCLAIMER:
-----------------------------------------------------------------------------------------------------------------------

The contents of this e-mail and any attachment(s) are confidential and intended for the named recipient(s) only.
It shall not attach any liability on the originator or HCL or its affiliates. Any views or opinions presented in 
this email are solely those of the author and may not necessarily reflect the opinions of HCL or its affiliates.
Any form of reproduction, dissemination, copying, disclosure, modification, distribution and / or publication of 
this message without the prior written consent of the author of this e-mail is strictly prohibited. If you have
received this email in error please delete it and notify the sender immediately. Before opening any mail and 
attachments please check them for viruses and defect.

-----------------------------------------------------------------------------------------------------------------------

_______________________________________________
DiME mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/dime

---

From: Oviaprasad D <[email-masked]>
Date: Tue, 24 Jul 2007 16:23:58 +0530

Hi Bala
    Sorry for the late reply.

As per RFC 3588 the state machine shows at the Responder side
Once it win the election its Initiator Disconnects and Responder will 
send CEA and the connection
is open for further communication. please refer bellow.
 
   Wait-Returns     Win-Election     I-Disc,R-Snd-CEA R-Open

at the same time whoever receives CEA(ie Initiator of the other end) 
should disconnects Responder
and keep Initiator connection for further communication.  This is more 
than enough I mean no need to
send CEA with error code saying election Lost. please refer the state 
machine bellow.

                    I-Rcv-CEA        R-Disc           I-Open

The state machine says both I-Disc and R-Disc happens hence the other 
connection is close and no use of
error code 4003.

but if you see section 7.1.4

<rfc>
7.1.4.  Transient Failures

ELECTION_LOST                      4003
      The peer has determined that it has lost the election process and
      has therefore disconnected the transport connection.
</rfc>

    The peer who lost the election can convey with error code 
ELECTION_LOST in his CEA.
Since RFC is not candidate anything about who is need to send this is 
upto Implementation specific
we can follow either of above this is my view if I am wrong please 
correct me.

regards
Oviya

Balamurugan T, TLS-Chennai wrote:
> Hi Oviys,
>
>    Thanks for your reply.
>
>    In Peer state FSm,
>
>      Wait-Returns     Win-Election     I-Disc,R-Snd-CEA R-Open
>
>     The above has no glue to send the CEA send with error code in Action function.
>     It simply say I-Disc.
>
> Regards,
> Bala
>
>
> -----Original Message-----
> From: Oviaprasad D [mailto:[email-masked]]
> Sent: Thursday, July 19, 2007 11:45 AM
> To: Balamurugan T, TLS-Chennai
> Subject: Re: [Dime] Clarification regarding Error code 4003.(Election
> lost)
>
>
> Hi Bala
>     As per the RFC 3588 [Page 66] Sec 5.6 says
> <begin quote>  
>
>    A CER message is always sent on the initiating connection immediately
>    after the connection request is successfully completed.  In the case
>    of an election, one of the two connections will shut down.  The
>    responder connection will survive if the Origin-Host of the local
>    Diameter entity is higher than that of the peer; the initiator
>    connection will survive if the peer's Origin-Host is higher.
> <end quote>
>
>     Basically the Origin-Host of Initiator and the peer compared, the 
> Higher
> of the responder connection will survive that is sent CEA(port) and 
> close his
> CER (port)connection by sending ELECTION_LOST 4003.
>
> Hope this solve your issue.
>
> regards
> Oviys
>
>
>
> Balamurugan T, TLS-Chennai wrote:
>   
>> Hi All,
>>
>>     In Peer state machine, the Initiator of a connection disconnects 
>> it on election win and sending CEA over responding
>>
>>     connection. Do we need to send CEA in Initiated connection before 
>> closing the connection?. If the answer is no,
>> ------------------------------------------------------------------------
>>
>> DISCLAIMER:
>> ------------------------------------------------------------------------
>>
> EMAIL DISCLAIMER : This email and any files transmitted with it are confidential and intended solely for the use of the individual or entity to whom they are addressed. Any unauthorised distribution or copying is strictly prohibited. If you receive this transmission in error, please notify the sender by reply email and then destroy the message. Opinions, conclusions and other information in this message that do not relate to official business of Mascon shall be understood to be neither given nor endorsed by Mascon. Any information contained in this email, when addressed to Mascon clients is subject to the terms and conditions in governing client contract.
>
> Whilst Mascon takes steps to prevent the transmission of viruses via e-mail, we can not guarantee that any email or attachment is free from computer viruses and you are strongly advised to undertake your own anti-virus precautions. Mascon grants no warranties regarding performance, use or quality of any e-mail or attachment and undertakes no liability for loss or damage, howsoever caused. 
>
>
>
>   

EMAIL DISCLAIMER : This email and any files transmitted with it are confidential and intended solely for the use of the individual or entity to whom they are addressed. Any unauthorised distribution or copying is strictly prohibited. If you receive this transmission in error, please notify the sender by reply email and then destroy the message. Opinions, conclusions and other information in this message that do not relate to official business of Mascon shall be understood to be neither given nor endorsed by Mascon. Any information contained in this email, when addressed to Mascon clients is subject to the terms and conditions in governing client contract.

Whilst Mascon takes steps to prevent the transmission of viruses via e-mail, we can not guarantee that any email or attachment is free from computer viruses and you are strongly advised to undertake your own anti-virus precautions. Mascon grants no warranties regarding performance, use or quality of any e-mail or attachment and undertakes no liability for loss or damage, howsoever caused.